.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\masm32.inc

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\masm32.lib


BUFFER_SIZE equ 100


.data

szWelcome   db 'Please type the file name :',13,10,0
format1     db 13,10,'The size of the file = %u bytes',0

.data?

hFile       dd ?
buffer      db BUFFER_SIZE dup(?)
buffer2     db BUFFER_SIZE dup(?)

.code

start:

    invoke  StdOut,ADDR szWelcome
    invoke  StdIn,ADDR buffer,BUFFER_SIZE

; A string returned by StdIn is terminated by the CR+LF,0 byte sequence : 13,10,0
; Replace the CR byte - ASCII 13 with 0

    mov     BYTE PTR [buffer+eax-2],0

    invoke  CreateFile,ADDR buffer,GENERIC_READ,0,0,\
            OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0

; If CreateFile fails terminate silently the application

    cmp     eax,INVALID_HANDLE_VALUE
    je      finish

    mov     hFile,eax

    invoke  GetFileSize,eax,0

    invoke  wsprintf,ADDR buffer2,ADDR format1,eax
    invoke  StdOut,ADDR buffer2

    invoke  CloseHandle,hFile

finish:

    invoke  ExitProcess,0

END start

